//+------------------------------------------------------------------+
//|                                              VininI_XMA11.V1.mq4 |
//|                                          Copyright  2009, Vinin |
//|                                             http://vinin.ucoz.ru |
//-------------------------------------------------------------------+
#property copyright "Copyright  2009, Vinin"
#property link      "http://vinin.ucoz.ru"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Green

extern double  porog =5.0;

//---- buffers
double Signal1[];
double Signal2[];
double Signal3[];

//+------------------------------------------------------------------+
void init(){
   IndicatorShortName("Xma("+DoubleToStr(porog,2)+")");
   SetIndexStyle(0,DRAW_LINE);  SetIndexDrawBegin(0,0); SetIndexBuffer(0,Signal1); SetIndexLabel(0,"Signal1");
   SetIndexStyle(1,DRAW_LINE);  SetIndexDrawBegin(1,0); SetIndexBuffer(1,Signal2); SetIndexLabel(1,"Signal2");
   SetIndexStyle(2,DRAW_ARROW); SetIndexDrawBegin(2,0); SetIndexBuffer(2,Signal3); SetIndexLabel(2,"Signal3"); SetIndexArrow( 2, 159);
   return;
} 
int deinit(){
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
int start() {
   int limit, trend;
   double tmp, tmpCandle, Price;
   int counted_bars=IndicatorCounted();
   int i;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   tmpCandle=porog/1000.0*Close[0];

   for (i=limit;i>=0;i--) {
      if (Signal1[i+1]==0) {
         Signal1[i]=(High[i]+Low[i])/2.0; 
         Signal2[i]=(High[i]+Low[i])/2.0; 
         Signal3[i]=(High[i]+Low[i])/2.0; 
         continue;
      } 
      
      Signal1[i]=Signal1[i+1];
      Signal2[i]=Signal2[i+1];
      Signal3[i]=Signal3[i+1];


      if (tmpCandle>porog) {
         Signal1[i]=(High[i]+Low[i])/2.0; 
         Signal2[i]=(High[i]+Low[i])/2.0; 
         Signal3[i]=(High[i]+Low[i])/2.0; 
         continue; 
      
      }
      
      Price=High[i];
      int Sign=1;
      if (High[i]-Signal1[i]<Signal1[i]-Low[i]) {
         Price=Low[i];
         Sign=-1;
      }
         
      if (MathAbs(Price-Signal1[i])>tmpCandle) {
            Signal1[i]=1000.0/(1000.0+Sign*porog)*Price; 
      }
      Price=High[i];
      Sign=1;
      if (Low[i]-Signal2[i]>High[i]-Signal2[i]) {
         Price=Low[i];
         Sign=-1;
      }         
      if (MathAbs(Price-Signal2[i])>tmpCandle) {
            Signal2[i]=(Price+1000.0/(1000.0+Sign*porog)*Price)/2.0; 
      }
      if (Signal2[i]>Signal1[i]) Signal3[i]=Signal1[i]-tmpCandle; else 
      if (Signal2[i]<Signal1[i]) Signal3[i]=Signal1[i]+tmpCandle;
      Comment("  =",DoubleToStr(tmpCandle,Digits));
   }
   return(0);
}
//+------------------------------------------------------------------+   

// int Sign(double a) {if (a>0) return(1); if (a<0) return(-1); return(0);}

